<div mat-dialog-actions class="close-button">
  <button
    mat-button
    (click)="cancel()"
    class="mat-focus-indicator close-dialog-button mat-icon-button mat-button-base ng-star-inserted"
  >
    <mat-icon attr.aria-label="Cancel">cancel</mat-icon>
  </button>
</div>
<div mat-dialog-content>
  <span *ngIf="!editMode" [innerHTML]="data.title"></span>
  <mat-form-field *ngIf="editMode">
    <input 
      matInput 
      name="title" 
      type="text" 
      placeholder="Add Title" 
      [(ngModel)]="data.title" 
      required
    />
  </mat-form-field>

  <markdown *ngIf="!editMode" [data]="data.content"></markdown>

  <!--<app-media-browser *ngIf="editMode" (addMedia)="addEntitySwitch($event)"></app-media-browser>-->

  <mat-form-field *ngIf="editMode">
    <textarea
      id="annotation-content"
      #annotationContents
      matInput
      cdkTextareaAutosize
      cdkAutosizeMinRows="1"
      name="description"
      type="text"
      placeholder="Add Description"
      [(ngModel)]="data.content"
    >
    </textarea>
  </mat-form-field>

  <mat-form-field *ngIf="editMode" class="search-field">
    <mat-label>Add description Author:</mat-label>
    <input
      matInput
      type="text"
      name="Agent"
      placeholder="Search for the description author"
      [formControl]="searchAgents"
      [matAutocomplete]="searchAgentAutocomplete"
    />
    <mat-icon matSuffix>search</mat-icon>
    <mat-autocomplete
      #searchAgentAutocomplete="matAutocomplete"
      [displayWith]="displayWikibaseItemLabel"
      (optionSelected)="selectAgent($event)"
    >
      <mat-option *ngFor="let agent of filteredAgents$ | async" [value]="agent">
        {{ agent.label['en'] }}
      </mat-option>
    </mat-autocomplete>
  </mat-form-field>

  <mat-form-field *ngIf="editMode" class="search-field">
    <mat-label>Add description license:</mat-label>
    <input
      matInput
      type="text"
      name="license"
      placeholder="Search for the description license"
      [formControl]="searchLicenses"
      [matAutocomplete]="searchLicenseAutocomplete"
    />
    <mat-icon matSuffix>search</mat-icon>
    <mat-autocomplete
      #searchLicenseAutocomplete="matAutocomplete"
      [displayWith]="displayWikibaseItemLabel"
      (optionSelected)="selectLicense($event)"
    >
      <mat-option *ngFor="let license of filteredLicenses$ | async" [value]="license">
        {{ license.label['en'] }}
      </mat-option>
    </mat-autocomplete>
  </mat-form-field>

  <!--
  <mat-form-field *ngIf="editMode">
    <textarea
      id="annotation-url"
      #annotationUrl
      matInput
      cdkTextareaAutosize
      cdkAutosizeMinRows="1"
      name="url"
      type="text"
      placeholder="Or Load from URL:"
      [(ngModel)]="data.url"
    >
    </textarea>
  </mat-form-field>
  -->

  <button
    *ngIf="editMode"
    mat-raised-button
    class="fake-primary"
    (click)="addAgentsAndLicenses()"
    [disabled]="selectedAgent$.value === undefined && selectedLicense$.value === undefined"
  >
    Add
  </button>

  <!--Display description metadata with cards-->
  <div
    *ngIf="data!.descriptionAuthors!.length + data!.descriptionLicenses!.length > 0"
    class="item-results"
  >
    <div class="item-results-label">Description Metadata:</div>
    <mat-card *ngFor="let author of data.descriptionAuthors" class="item-result">
      <mat-card-header>
        <mat-card-title class="item-result-entry">
          <a [href]="author.id">Author: {{ author.label['en'] }}</a>
          <button
            *ngIf="editMode && data.isAnnotatingAllowed && data.isAnnotationOwner"
            mat-button
            (click)="removeDescriptionAuthor(author.id)"
          >
            <mat-icon attr.aria-label="Delete">delete</mat-icon>
          </button>
        </mat-card-title>
      </mat-card-header>
    </mat-card>
    <mat-card *ngFor="let license of data.descriptionLicenses" class="item-result">
      <mat-card-header>
        <mat-card-title class="item-result-entry">
          <a [href]="license.id">License: {{ license.label['en'] }}</a>
          <button
            *ngIf="editMode && data.isAnnotatingAllowed && data.isAnnotationOwner"
            mat-button
            (click)="removeDescriptionLicense(license.id)"
          >
            <mat-icon attr.aria-label="Delete">delete</mat-icon>
          </button>
        </mat-card-title>
      </mat-card-header>
    </mat-card>
  </div>

  <hr />

  <mat-form-field *ngIf="editMode" class="search-field">
    <mat-label>Add related media:</mat-label>
    <input
      matInput
      type="text"
      name="media"
      placeholder="Search for media"
      [formControl]="searchMedia"
      [matAutocomplete]="mediaAutocomplete"
    />
    <mat-icon matSuffix>search</mat-icon>
    <mat-autocomplete
      #mediaAutocomplete="matAutocomplete"
      [displayWith]="displayWikibaseItemLabel"
      (optionSelected)="selectMedium($event)"
    >
      <mat-option *ngFor="let medium of filteredMedia$ | async" [value]="medium">
        {{ medium.label['en'] }}
      </mat-option>
    </mat-autocomplete>
  </mat-form-field>

<!--   <mat-form-field *ngIf="editMode">
    <input
      matInput
      #annotationRelUrl
      placeholder="Or provide remote URL:"
      name="related-media-url"
      type="text"
      [(ngModel)]="relatedMediaUrl"
    />
  </mat-form-field> -->

  <button
    *ngIf="editMode"
    mat-raised-button
    class="fake-primary"
    (click)="addRelatedMedia()"
    [disabled]="!relatedMediaUrl.length && selectedMedium$.value === undefined"
  >
    Add
  </button>

<!--   <div class="warning">
    <span>
      * Editing or deleting remote media URLs after you’ve added them once is not possible in this version of Semantic Kompakkt.    </span>
  </div> -->

  <div
    *ngIf="data.relatedMedia.length > 0 || data.relatedMediaUrls.length > 0"
    class="item-results"
  >
    <div class="item-results-label">Related Media:</div>
    <mat-card *ngFor="let medium of data.relatedMedia" class="item-result">
      <mat-card-header>
        <mat-card-title class="item-result-entry">
          <a [href]="medium.id">{{ medium.label['en'] }}</a> <br /><br />
          <img [src]="medium.media" />

          <button
            *ngIf="editMode && data.isAnnotatingAllowed && data.isAnnotationOwner"
            mat-button
            (click)="removeRelatedMedia(medium.id)"
          >
            <mat-icon attr.aria-label="Delete">delete</mat-icon>
          </button>
        </mat-card-title>
      </mat-card-header>
    </mat-card>
    <mat-card *ngFor="let medium of data.relatedMediaUrls" class="item-result">
      <mat-card-header>
        <mat-card-title class="item-result-entry">
          <a [href]="medium">{{ medium }}</a>
          <button
            *ngIf="editMode && data.isAnnotatingAllowed && data.isAnnotationOwner"
            mat-button
            (click)="removeRelatedMediaUrls(medium)"
          >
            <mat-icon attr.aria-label="Delete">delete</mat-icon>
          </button>
        </mat-card-title>
      </mat-card-header>
    </mat-card>
  </div>
  <hr />
  <mat-form-field *ngIf="editMode" class="search-field">
    <mat-label>Add related semantic concepts:</mat-label>
    <input
      matInput
      type="text"
      name="concepts"
      placeholder="Search for concepts"
      [formControl]="searchConcepts"
      [matAutocomplete]="conceptsAutocomplete"
    />
    <mat-icon matSuffix>search</mat-icon>
    <mat-autocomplete
      #conceptsAutocomplete="matAutocomplete"
      [displayWith]="displayWikibaseItemLabel"
      (optionSelected)="selectConcept($event)"
    >
      <mat-option *ngFor="let concept of filteredConcepts$ | async" [value]="concept">
        {{ concept.label['en'] }}
      </mat-option>
    </mat-autocomplete>
  </mat-form-field>
  <!-- Button to add related entities -->
  <button
    *ngIf="editMode"
    mat-raised-button
    class="fake-primary"
    (click)="addRelatedConcept()"
    [disabled]="selectedConcept$.value === undefined"
  >
    Add
  </button>

  <!--Display entity with cards-->
  <div *ngIf="data.relatedConcepts.length > 0" class="item-results">
    <div class="item-results-label">Related Concepts:</div>
    <mat-card *ngFor="let concept of data.relatedConcepts" class="item-result">
      <mat-card-header>
        <mat-card-title class="item-result-entry">
          <a [href]="concept.id">{{ concept.label['en'] }}</a>
          <button
            *ngIf="editMode && data.isAnnotatingAllowed && data.isAnnotationOwner"
            mat-button
            (click)="removeRelatedConcept(concept.id)"
          >
            <mat-icon attr.aria-label="Delete">delete</mat-icon>
          </button>
        </mat-card-title>
      </mat-card-header>
    </mat-card>
  </div>
</div>

<div mat-dialog-actions>
  <button mat-button (click)="toggleEditViewMode()" attr.aria-label="{{ labelModeText }}">
    <mat-icon>{{ labelMode }}</mat-icon>
  </button>
  <button mat-button [mat-dialog-close]="data">
    <mat-icon attr.aria-label="Save">save</mat-icon>
  </button>

  <button
    *ngIf="data.isAnnotatingAllowed && data.isAnnotationOwner"
    mat-button
    [mat-dialog-close]="{ remove: true }"
  >
    <mat-icon attr.aria-label="Delete">delete</mat-icon>
  </button>
</div>
